# Written by Bram Cohen
# see LICENSE.txt for license information

from time import time

#import time as mtime
##gt = mtime.time()
##
##def time():
##    return gt

class Measure(object):
    def __init__(self, max_rate_period, fudge = 1, total=0L):
        self.max_rate_period = max_rate_period
        self.max_rate_period_hist = 60*60
        self.ratesince = time() - fudge
        self.ratesince_hist = time() - fudge
        self.last = self.ratesince
        self.last_hist = self.ratesince
        self.rate = 0.0
        self.rate_hist = 0.0    #long term historic rate
        self.total = total
        self.session_total = 0

    def update_rate(self, amount):
        self.total += amount
        self.session_total += amount
        t = time()
        self.rate = (self.rate * (self.last - self.ratesince) + 
            amount) / max(0.0001, t - self.ratesince)
        self.last = t
        if self.ratesince < t - self.max_rate_period:
            self.ratesince = t - self.max_rate_period

        self.rate_hist = max(0.0001, self.rate_hist * (self.last_hist - self.ratesince_hist) + 
            amount) / max(0.0001, t - self.ratesince_hist)
        self.last_hist = t
        if self.ratesince_hist < t - self.max_rate_period_hist:
            self.ratesince_hist = t - self.max_rate_period_hist


    def get_rate_hist(self):
        self.update_rate(0)
        return self.rate_hist

    def get_rate(self):
        self.update_rate(0)
        return self.rate

    def get_rate_noupdate(self):
        return self.rate

    def time_until_rate(self, newrate):
        if self.rate <= newrate:
            return 0
        t = time() - self.ratesince
        return ((self.rate * t) / newrate) - t

    def get_total(self):
        return self.total

    def get_session_total(self):
        return self.session_total
    


if __name__ == '__main__':
    m = Measure(10)
    #m = Measure(1)
    
    for i in range(10):
        m.update_rate(20)
        print m.get_rate(), m.get_rate_hist()
        gt += 1
        
    for i in range(60):
        m.update_rate(0)
        print m.get_rate(), m.get_rate_hist()
        gt += 1        

    for i in range(10):
        m.update_rate(120)
        print m.get_rate(), m.get_rate_hist()
        gt += 1        