#-----------------------------------------------------------------------------
# Name:        g3peerid.py
# Purpose:     
#
# Author:      Jeremy Arendt
#
# Created:     2004/24/02
# RCS-ID:      $Id: g3peerid.py $
# Copyright:   (c) 2002
# Licence:     See G3.LICENCE
#-----------------------------------------------------------------------------

from sys import argv
from sha import sha
from time import time
from os import getpid
from binascii import b2a_hex
from BitTorrent.ClientIdentifier import identify_client

def GetPeerName(peerid):
    name_str = ""
    if peerid and len(peerid) == 20 and peerid[1:3] == "G3":
        verbyte = peerid[1:3]

        for c in peerid[3:12]:
            if c != chr(0) and c.isalnum():
                name_str += c
            else:
                break

    return name_str
    
    
def GetClientName(peerid):
    return "%s %s" % identify_client(peerid)
        
def GetClientName2(peerid):
    if peerid == None or len(peerid) == 0:
        return ""

    if peerid[1:3] == "G3":
        return "G3 Torrent"

    if peerid[:3] == (chr(0)*3):
        return "BitTorrent"

    if peerid[:1] == "M":
        version_str = ""
        for c in peerid[1:8]:
            if c == '-' or c.isalnum():
                version_str += c
            else:
                break
        version_str = version_str.replace('-', '.')
        return "BitTorrent " + version_str[:len(version_str)-2]
                
    if peerid[:3] == "-AZ":
        version_str = ""
        for c in peerid[3:10]:
            if c != '-' and c.isalnum():
                version_str += (c + '.')
            else:
                break
                        
        return "Azureus " + version_str[:len(version_str)-1]

    if peerid[:1] == "S":
        version_str = ""
        for c in peerid[1:10]:
            if c != '-' and c.isalnum():
                version_str += (c + '.')
            else:
                break

        return "Shadow " + version_str[:len(version_str)-1]
        
    if peerid[:1] == "T":
        version_str = ""
        for c in peerid[1:10]:
            if c != '-' and c.isalnum():
                version_str += (c + '.')
            else:
                break

        return "BitTornado " + version_str[:len(version_str)-1]

    if peerid[:1] == "A":
        version_str = ""
        for c in peerid[1:10]:
            if c != '-' and c.isalnum():
                version_str += (c + '.')
            else:
                break

        return "ABC " + version_str[:len(version_str)-1]

    if peerid[:3] == "-MT":
        version_str = ""
        for c in peerid[3:10]:
            if c != '-' and c.isalnum():
                version_str += (c + '.')
            else:
                break
                        
        return "Moonlight " + version_str[:len(version_str)-1]

    if peerid[:1] == "U":
        version_str = ""
        for c in peerid[1:10]:
            if c != '-' and c.isalnum():
                version_str += (c + '.')
            else:
                break

        return "UPnP " + version_str[:len(version_str)-1]

    if peerid[:3] == "-LT":
        version_str = ""
        for c in peerid[3:10]:
            if c != '-' and c.isalnum():
                version_str += (c + '.')
            else:
                break
                        
        return "libtorrent " + version_str[:len(version_str)-1]

    if peerid[:3] == "-BX":
        version_str = ""
        for c in peerid[3:10]:
            if c != '-' and c.isalnum():
                version_str += (c + '.')
            else:
                break
                        
        return "Bittorrent X " + version_str[:len(version_str)-1]

    if peerid[:3] == "-TS":
        version_str = ""
        for c in peerid[3:10]:
            if c != '-' and c.isalnum():
                version_str += (c + '.')
            else:
                break
                        
        return "Torrentstorm " + version_str[:len(version_str)-1]
    
    if peerid[:4] == "Plus":
        return "Plus! II"

    return ""

def CreatePeerId(nick = "", type = 0):
    #["G3 Torrent (Default)", "BitTorrent 3.4.2", "Bittorrent 0.3.10", "Azureus 2.2.0.2"]
    nick = str(nick) # Sanity check.
    if type == 0:
        nick = nick.encode('latin-1')
        if len(nick) == 0:
            mynick = "Unnamed" + (chr(0) * 2)
        elif len(nick) > 9:
            mynick = nick[:9]
        elif len(nick) < 9:
            mynick = nick + (chr(0) * (9 - len(nick)))
        else:
            mynick = nick        
        peerid = '-G3' + mynick + sha(repr(time()) + ' ' + str(getpid())).digest()[-8:]
    elif type == 1:
        #peerid = (chr(0) * 12) + sha(repr(time()) + ' ' + str(getpid())).digest()[-8:]
        peerid = 'M3-4-2' + '--' + b2a_hex(sha(repr(time()) + ' ' + str(getpid())).digest()[-6:])
    elif type == 2:
        peerid = 'T03A' + ('-' * 5)
        mapbase64 = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz.-'
        for i in sha(repr(time()) + str(getpid())).digest()[-11:]:
            peerid += mapbase64[ord(i) & 0x3F]
    elif type == 3:
        peerid = '-AZ2202-' + sha(repr(time()) + ' ' + str(getpid())).digest()[-12:]

    return peerid


if __name__ == '__main__':
    print CreatePeerId("g3rmz")
    print CreatePeerId("g3rmz", 2)
    print CreatePeerId("Anonymous"), len(CreatePeerId("Anonymous"))
    print GetPeerName(CreatePeerId("Anonymous"))
    print GetClientName(CreatePeerId("g3rmz", 0))
    print GetClientName(CreatePeerId("g3rmz", 1))
    print GetClientName(CreatePeerId("g3rmz", 2))
    print GetClientName(CreatePeerId("g3rmz", 3))
