; g3torrent.nsi
;
; This script is based on example1.nsi, but it remember the directory, 
; has uninstall support and (optionally) installs start menu shortcuts.
;
; It will install makensisw.exe into a directory that the user selects,

;--------------------------------
SetCompressor lzma

; The name of the installer
Name "g3torrent"

; The file to write
OutFile "g3torrent.exe"

; The default installation directory
InstallDir $PROGRAMFILES\g3torrent

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\NSIS_g3torrent" "Install_Dir"

;--------------------------------

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "g3torrent"

  SectionIn RO
  
  SetOutPath $INSTDIR
  Delete $INSTDIR\*.log
  File dist\*.*
  SetOutPath $INSTDIR\images
  File dist\images\*.*
  SetOutPath $INSTDIR\images\flags
  File dist\images\flags\*.*
  SetOutPath $INSTDIR

  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\NSIS_g3torrent "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\g3torrent" "DisplayName" "G3 Torrent"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\g3torrent" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\g3torrent" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\g3torrent" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

Section "Associate with *.torrent files"
  ; Delete any existing keys
  DeleteRegKey HKCR "Applications\btdownloadgui.exe"
  DeleteRegKey HKCR "Applications\Azureus.exe"

  ; Write the file association
  WriteRegStr HKCR .torrent "" bittorrent
  WriteRegStr HKCR .torrent "Content Type" application/x-bittorrent
  WriteRegStr HKCR "MIME\Database\Content Type\application/x-bittorrent" Extension .torrent
  WriteRegStr HKCR bittorrent "" "TORRENT File"
  WriteRegBin HKCR bittorrent EditFlags 00000100
  WriteRegStr HKCR "bittorrent\shell" "" open
  WriteRegStr HKCR "bittorrent\shell\open\command" "" `"$INSTDIR\g3torrent.exe" "%1"`
SectionEnd




Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\G3 Torrent"
  CreateShortCut "$SMPROGRAMS\G3 Torrent\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\G3 Torrent\G3 Torrent.lnk" "$INSTDIR\g3torrent.exe" "" "$INSTDIR\g3torrent.exe" 0

SectionEnd

Section "Desktop Shortcuts"

  CreateShortCut "$DESKTOP\G3 Torrent.lnk" "$INSTDIR\g3torrent.exe" "" "$INSTDIR\g3torrent.exe" 0
  
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKCR .torrent
  DeleteRegKey HKCR "MIME\Database\Content Type\application/x-bittorrent"
  DeleteRegKey HKCR bittorrent
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\g3torrent"
  DeleteRegKey HKLM SOFTWARE\NSIS_g3torrent

  ; Remove files and uninstaller
  Delete $INSTDIR\g3torrent.exe
  Delete $INSTDIR\w9xpopen.exe
  Delete $INSTDIR\*.pyd
  Delete $INSTDIR\*.dll
  Delete $INSTDIR\*.zip
  Delete $INSTDIR\*.txt
  Delete $INSTDIR\*.ini
  Delete $INSTDIR\*.log
  Delete $INSTDIR\*.pyg

  Delete $INSTDIR\images\flags\*.ico
  RMDir "$INSTDIR\images\flags"

  Delete $INSTDIR\images\*.png
  Delete $INSTDIR\images\*.bmp
  Delete $INSTDIR\images\*.ico
  RMDir "$INSTDIR\images"

  Delete $INSTDIR\uninstall.exe


  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\g3torrent\*.*"


  ; Remove directories used
  RMDir "$SMPROGRAMS\g3torrent"
  RMDir "$INSTDIR"

SectionEnd