import locale
from types import StringType, UnicodeType

def unihack(s):
    if type(s) is StringType:
        try:
            s = s.decode(locale.getpreferredencoding())
        except (UnicodeDecodeError, LookupError):
            s = s.decode('latin-1', 'replace')
    return s


def fromutf8(s):
    if type(s) is StringType:
        try:
            s = s.decode('utf-8')
        except (UnicodeDecodeError, LookupError):
            s = s.decode(locale.getpreferredencoding(), 'replace')
    return s
    