#-----------------------------------------------------------------------------
# Name:        optiondlg.py
# Purpose:     
#
# Author:      Jeremy Arendt
#
# Created:     2004/30/01
# RCS-ID:      $Id: optiondlg.py $
# Copyright:   (c) 2002
# Licence:     See G3.LICENCE.TXT
#-----------------------------------------------------------------------------

import wx
from wx.lib.masked import IpAddrCtrl, TextCtrl
from wx.lib.masked import NumCtrl
from traceback import print_exc
from images import Images
from btconfig import BTConfig
from os.path import join
from time import strftime, gmtime
from g3version import prog_version
from webbrowser import open_new
from threading import Thread
import sys
import socket
import random
import locale
from g3unihack import *
if sys.platform == "win32":
    from _winreg import *


Widget_H = 20

class About_Box(wx.Frame):
    def __init__(self, parent, btconfig, images, pos = (-1,-1)):
        wx.Frame.__init__(self, parent, -1, "About", pos, size = (320,240))
        panel = wx.Panel(self, -1)
        
        self.btconfig = btconfig        
       
        about_text1 = wx.StaticText(panel, -1,
                                  ("G3 Torrent version: %s" % prog_version)
                                    + "\nBy Jeremy Arendt")
                                
        about_text2 = wx.StaticText(panel, -1, "Home Page: ")
        url_text = wx.StaticText(panel, -1, "http://g3torrent.sourceforge.net")
        url_text.SetForegroundColour('Blue')
                                
        about_text3 = wx.StaticText(panel, -1,
                                "Contact: germz@users.sourceforge.net"
                                + "\n\nBitTorrent was written by Bram Cohen "
                                + "\n  and Myers Carpenter"
                                + "\n\nBitTorrent is a trademark of Bram Cohen\n")
                                
        about_text4 = wx.StaticText(panel, -1, "Python %s\nwxWidgets %s" %
                                (sys.version.split('(')[0], wx.__version__))
        
        logo = wx.StaticBitmap(panel, -1, images.GetImage('g3.bmp'))
        
        okbut = wx.Button(panel, -1, 
                random.choice(["Marvelous!", "Ok!", "Werd!", "Yay!", "Booya!"]))
        
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double = wx.FlexGridSizer(cols = 2)
        boxer = wx.FlexGridSizer(cols = 2)
        
        double.Add(about_text2)
        double.Add(url_text)
        tall.Add((-1,10)) # spacer
        tall.Add(about_text1)
        tall.Add(double)
        tall.Add(about_text3)
        tall.Add(about_text4)
        
        tall.Add(okbut, 1, wx.ALIGN_RIGHT)
        tall.AddGrowableCol(0)
        boxer.AddGrowableCol(1)
        
        boxer.Add(logo, 1, wx.ALL, 4)
        boxer.Add(tall, 1, wx.EXPAND | wx.ALL, 4)
        panel.SetSizer(boxer)
        panel.Layout()
        wx.EVT_LEFT_DOWN(url_text, self.OnUrlClick)
        wx.EVT_CLOSE(self, self.Close)
        wx.EVT_BUTTON(self, okbut.GetId(), self.Close)
        wx.EVT_KEY_DOWN(okbut, self.Close)
        
        self.SetIcon( images.GetImage('tbicon') )
        self.Show(True)

    def _OpenUrl(self):
        open_new('http://g3torrent.sourceforge.net')
            
    def OnUrlClick(self, event):
        Thread(target = self._OpenUrl).start()
    
    def Close(self, event):
        self.Destroy()
        
        
class Options_About_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        
        box = wx.StaticBox(self, -1, "About", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double = wx.FlexGridSizer(cols = 2)
        
        about_text1 = wx.StaticText(self, -1,
                                  ("G3 Torrent version: %s" % prog_version)
                                    + "\nBy Jeremy Arendt")
                                
        about_text2 = wx.StaticText(self, -1, "Home Page: ")
        url_text = wx.StaticText(self, -1, "http://g3torrent.sourceforge.net")
        url_text.SetForegroundColour('Blue')
                                
        about_text3 = wx.StaticText(self, -1,
                                "Contact: germz@users.sourceforge.net"
                                + "\n\nBitTorrent was written by Bram Cohen "
                                + "\n  and Myers Carpenter"
                                + "\n\nBitTorrent is a trademark of Bram Cohen\n\n")
                                
        about_text4 = wx.StaticText(self, -1, "Python %s\nwxWidgets %s  --  Platform: %s" %
                                (sys.version, wx.__version__, wx.Platform)
                                )
        double.Add(about_text2)
        double.Add(url_text)
        tall.Add((psize[0] - 10,10)) # spacer
        tall.Add(about_text1)
        tall.Add(double)
        tall.Add(about_text3)
        tall.Add(about_text4)
        
        
        tall.AddGrowableCol(0)        
        boxer.Add(tall, 1, flag = wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()
        wx.EVT_LEFT_DOWN(url_text, self.OnUrlClick)

    def _OpenUrl(self):
        open_new('http://g3torrent.sourceforge.net')
            
    def OnUrlClick(self, event):
        Thread(target = self._OpenUrl).start()
    
    def SaveSettings(self):
        pass

#-----------------------------------------------------------------------------

class Options_SchedCmd_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig
        self.cmd_dict = {"None": "", "Shutdown PC (XP)": "shutdown -s -t 90", "Custom Command": ""}
        cmd_choices = ["None", "Shutdown PC (XP)", "Custom Command"]
        
        box = wx.StaticBox(self, -1, "Schedule a system command", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        notebox = wx.StaticBox(self, -1, "Note", size = psize)
        noteboxer = wx.StaticBoxSizer(notebox, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double = wx.FlexGridSizer(cols = 2, vgap = 4, hgap = 4)
        
        oncompbox = wx.StaticBox(self, -1, "On Download Stop")
        oncompboxer = wx.StaticBoxSizer(oncompbox, wx.HORIZONTAL)
        
        label1 = wx.StaticText(self, -1, "  Action:")
        label2 = wx.StaticText(self, -1, "  Command string:")
        self.combo1 = wx.ComboBox(self, -1, size = wx.Size(200, Widget_H),
                choices = cmd_choices, style=wx.CB_READONLY )
        
        self.cmd1 = wx.TextCtrl(self, -1, size=wx.Size(200, Widget_H))

        run_cmd = unihack(btconfig.Get("on_stop_runcmd"))
        if run_cmd:
            self.combo1.SetSelection(2)
            self.cmd1.SetValue(run_cmd)
        else:
            self.combo1.SetSelection(0)
            self.cmd1.Disable()
                                
        notetext = wx.StaticText(self, -1,
                                  "You can schedule a system commnad to run on a g3 event here.\n\n"
                                + ""
                                + "")
                                
        noteboxer.Add(notetext, 1, wx.EXPAND)
        double.AddGrowableCol(0)
        double.Add((-1,3))
        double.Add((-1,3))
        double.Add(label1, 1, wx.EXPAND)
        double.Add(self.combo1, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        double.Add(label2, 1, wx.EXPAND)
        double.Add(self.cmd1, 1, wx.EXPAND | wx.ALIGN_RIGHT)

        oncompboxer.Add(double, 1, wx.EXPAND)

        tall.AddGrowableCol(0)
        tall.AddGrowableRow(3)
        tall.Add((-1,5)) # spacer
        tall.Add(oncompboxer, 1, wx.EXPAND)
        tall.Add((-1,50)) # spacer
        tall.Add(noteboxer, 1, wx.EXPAND)
        
        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)
        
        self.Bind(wx.EVT_COMBOBOX, self.OnComboChange, self.combo1)
        
        self.Layout()
    
    def OnComboChange(self, event):
        value = self.combo1.GetValue()
        self.cmd1.SetValue( self.cmd_dict[value] )
        
        if value == "None":
            self.cmd1.SetValue("")
            self.cmd1.Disable()
        else:
            self.cmd1.Enable()
    
    def SaveSettings(self):
        run_cmd = self.cmd1.GetValue()        
        self.btconfig.Set("on_stop_runcmd", run_cmd)
        
#-----------------------------------------------------------------------------

class Options_Spoof_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig
        self.client_choices = ["G3 Torrent (Default)", "BitTorrent 3.4.2", "BitTornado 0.3.10", "Azureus 2.2.0.2"]
        box = wx.StaticBox(self, -1, "Client Spoofing", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        notebox = wx.StaticBox(self, -1, "Note", size = psize)
        noteboxer = wx.StaticBoxSizer(notebox, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double = wx.FlexGridSizer(cols = 2)
        
        label1 = wx.StaticText(self, -1, "  Identify self as:")
        self.combo1 = wx.ComboBox(self, -1, size = wx.Size(180, Widget_H),
                choices = self.client_choices, style=wx.CB_READONLY )
        
        self.combo1.SetValue( self.client_choices[ btconfig.Get("client_type") ] )
                                
        notetext = wx.StaticText(self, -1,
                                  "Some trackers only allow certain types of clients to utilize them.\n\n"
                                + "Though these situations are quite rare, but should you encounter them, here are a "
                                + "few other common alternate BitTorrent clients you can have this program report itself as\n\n"
                                + "This program must be restarted for this change to take effect")
                                
        noteboxer.Add(notetext, 1, wx.EXPAND)
        double.AddGrowableCol(0)
        double.Add(label1, 1, wx.EXPAND)
        double.Add(self.combo1, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        tall.AddGrowableCol(0)
        tall.AddGrowableRow(3)
        tall.Add((-1,5)) # spacer
        tall.Add(double, 1, wx.EXPAND)
        tall.Add((-1,80)) # spacer
        tall.Add(noteboxer, 1, wx.EXPAND)
        
        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()
    
    def SaveSettings(self):
        client_type = self.combo1.GetValue()
        choice = self.client_choices.index(client_type)
        self.btconfig.Set("client_type", choice)
        
#-----------------------------------------------------------------------------

class Options_Fold_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        
        box = wx.StaticBox(self, -1, "Folder Options", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        doublewide = wx.FlexGridSizer(cols = 3, vgap = 2, hgap = 4)
        
        self.chk_id1 = wx.NewId()
        self.chk_id2 = wx.NewId()
        self.chk_id3 = wx.NewId()
        self.chk_id4 = wx.NewId()
        self.chk_id5 = wx.NewId()
        
        label1 = wx.StaticText(self, -1, "Incoming downloads go here:")
        self.check1 = wx.CheckBox(self, self.chk_id1, "", wx.Point(0, 0), wx.Size(-1, Widget_H), wx.NO_BORDER)
        self.edit1 = wx.TextCtrl(self, -1, "", size=(-1, Widget_H))
        self.button1 = wx.Button(self, 100, "...", size=(25,Widget_H))
        self.edit1.SetValue(unihack(btconfig.Get('download_dir')))
        
        label2 = wx.StaticText(self, -1, ".torrent metafiles get stored here:")
        self.check2 = wx.CheckBox(self, self.chk_id2, "", wx.Point(0, 0), wx.Size(-1, Widget_H), wx.NO_BORDER)
        self.edit2 = wx.TextCtrl(self, -1, "", size=(-1, Widget_H))
        self.button2 = wx.Button(self, 101, "...", size=(25,Widget_H))
        self.edit2.SetValue(unihack(btconfig.Get('torrent_dir')))
        
        label3 = wx.StaticText(self, -1, "Move completed downloads here:")
        self.check3 = wx.CheckBox(self, self.chk_id3, "", wx.Point(0, 0), wx.Size(-1, Widget_H), wx.NO_BORDER)
        self.edit3 = wx.TextCtrl(self, -1, "", size=(-1, Widget_H))
        self.button3 = wx.Button(self, 102, "...", size=(25,Widget_H))
        self.edit3.SetValue(unihack(btconfig.Get('completed_dl_dir')))

        label4 = wx.StaticText(self, -1, "Move completed .torrent folder here:")
        self.check4 = wx.CheckBox(self, self.chk_id4, "", wx.Point(0, 0), wx.Size(-1, Widget_H), wx.NO_BORDER)
        self.edit4 = wx.TextCtrl(self, -1, "", size=(-1, Widget_H))
        self.button4 = wx.Button(self, 103, "...", size=(25,Widget_H))
        self.edit4.SetValue(unihack(btconfig.Get('completed_tor_dir')))
        
        self.check5 = wx.CheckBox(self, self.chk_id5, "Scan and load unloaded .torrents every", wx.Point(0, 0), wx.Size(-1, Widget_H), wx.NO_BORDER)
        label5 = wx.StaticText(self, -1, "mins")
        self.spin1 = wx.SpinCtrl(self, -1, "", size=(50,Widget_H))
        self.spin1.SetValue(btconfig.Get('tdir_scan')/60)
        self.spin1.SetRange(0,100)
        
        scanizer = wx.FlexGridSizer(cols=3, hgap=2)
        scanizer.Add(self.check5)
        scanizer.Add(self.spin1)
        scanizer.Add(label5, 1, wx.NORTH, 4)
        
        if btconfig.Get('tdir_scan') > 0:
            self.check5.SetValue(True)
        
        if btconfig.Get('use_download_dir'):
            self.check1.SetValue(True)
            if btconfig.Get('download_dir') == btconfig.Get('completed_dl_dir'):
                self.check3.SetValue(False)
            else:
                self.check3.SetValue(True)
        else:
            self.check1.SetValue(False)
            self.check3.SetValue(False)
            
        if btconfig.Get('use_torrent_dir'):
            self.check2.SetValue(True)
            if btconfig.Get('torrent_dir') == btconfig.Get('completed_tor_dir'):
                self.check4.SetValue(False)
            else:
                self.check4.SetValue(True)
        else:
            self.check2.SetValue(False)
            self.check4.SetValue(False)
        
        wx.EVT_CHECKBOX(self, self.chk_id1, self.OnCheck) 
        wx.EVT_CHECKBOX(self, self.chk_id2, self.OnCheck) 
        wx.EVT_CHECKBOX(self, self.chk_id3, self.OnCheck) 
        wx.EVT_CHECKBOX(self, self.chk_id4, self.OnCheck)
        wx.EVT_CHECKBOX(self, self.chk_id5, self.OnCheck)
        
        # if seperate tooltip objs are not created, wxwindows will crash!
        tt = wx.ToolTip("Files will download into this folder")
        self.edit1.SetToolTip(tt)
        tt = wx.ToolTip("Files will download into this folder")
        self.check1.SetToolTip(tt)
        tt = wx.ToolTip("*.torrent metafiles will be copied to this folder")
        self.edit2.SetToolTip(tt)
        tt = wx.ToolTip("*.torrent metafiles will be copied to this folder")
        self.check2.SetToolTip(tt)
        tt = wx.ToolTip("When a download completes, the file will be moved here")
        self.edit3.SetToolTip(tt)
        tt = wx.ToolTip("When a download completes, the file will be moved here")
        self.check3.SetToolTip(tt)
        tt = wx.ToolTip("When a download completes, the *.torrent metafile will be moved here")
        self.edit4.SetToolTip(tt)
        tt = wx.ToolTip("When a download completes, the *.torrent metafile will be moved here")
        self.check4.SetToolTip(tt)
        tt = wx.ToolTip("Requires that the torrents and incoming folders be enabled")
        self.check5.SetToolTip(tt)
        
        wx.EVT_BUTTON(self, 100, self.OnButton)
        wx.EVT_BUTTON(self, 101, self.OnButton)
        wx.EVT_BUTTON(self, 102, self.OnButton)
        wx.EVT_BUTTON(self, 103, self.OnButton)

        doublewide.AddGrowableCol(1)
        
        doublewide.Add( (-1,-1) )
        doublewide.Add(label1, 1, wx.EXPAND)
        doublewide.Add( (-1,-1) )
        doublewide.Add(self.check1, 1, wx.EXPAND)
        doublewide.Add(self.edit1, 1, wx.EXPAND)
        doublewide.Add(self.button1, 1, wx.EXPAND)
        
        doublewide.Add( (-1,-1) )
        doublewide.Add(label2, 1, wx.EXPAND)
        doublewide.Add( (-1,-1) )
        doublewide.Add(self.check2, 1, wx.EXPAND)
        doublewide.Add(self.edit2, 1, wx.EXPAND)
        doublewide.Add(self.button2, 1, wx.EXPAND)
        
        doublewide.Add( (-1,-1) )
        doublewide.Add(label3, 1, wx.EXPAND)
        doublewide.Add( (-1,-1) )
        doublewide.Add(self.check3, 1, wx.EXPAND)
        doublewide.Add(self.edit3, 1, wx.EXPAND)
        doublewide.Add(self.button3, 1, wx.EXPAND)

        doublewide.Add( (-1,-1) )
        doublewide.Add(label4, 1, wx.EXPAND)
        doublewide.Add( (-1,-1) )
        doublewide.Add(self.check4, 1, wx.EXPAND)
        doublewide.Add(self.edit4, 1, wx.EXPAND)
        doublewide.Add(self.button4, 1, wx.EXPAND)
        
        notebox1 = wx.StaticBox(self, -1, "Note")
        noteboxer1 = wx.StaticBoxSizer(notebox1, wx.VERTICAL)
        self.notelabel = wx.StaticText(self, -1, "Leave these checkboxes are unchecked if you rather "
                                               + "be queried for the location at runtime"
                                               + "\n\nChanges to paths will not affect any existing downloads still in progress")
        noteboxer1.Add(self.notelabel, 1, wx.EXPAND)

        tall.Add((-1,10)) # spacer
        tall.Add(doublewide, 1, wx.EXPAND)
        tall.Add((-1,10)) # spacer
        tall.Add(scanizer, 1, wx.EXPAND)
        tall.Add(noteboxer1, 1, wx.EXPAND)
        
        tall.AddGrowableRow(4)
        tall.AddGrowableCol(0)
        boxer.Add(tall, 1, flag = wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()
        
        self.OnCheck(self.check1)
        self.OnCheck(self.check2)
        self.OnCheck(self.check3)
        self.OnCheck(self.check4)
        self.OnCheck(self.check5)
        

    def OnCheck(self, event):
        id = event.GetId()
        cbox = event
        
        if id == self.chk_id1:
            self.edit1.Enable( cbox.IsChecked() )
            self.button1.Enable( cbox.IsChecked() )
                
            if not cbox.IsChecked():
                self.check3.SetValue(False)
                self.edit3.Enable( False )
                self.button3.Enable( False )
                self.check5.SetValue( False )
                self.spin1.Enable( False )
            
        if id == self.chk_id2:
            self.edit2.Enable( cbox.IsChecked() )
            self.button2.Enable( cbox.IsChecked() )
        
            if not cbox.IsChecked():
                self.check4.SetValue(False)
                self.edit4.Enable( False )
                self.button4.Enable( False )
                self.check5.SetValue( False )
                self.spin1.Enable( False )
                
        if id == self.chk_id3:
            self.edit3.Enable( cbox.IsChecked() )
            self.button3.Enable( cbox.IsChecked() )
            
            if cbox.IsChecked():
                self.check1.SetValue(True)
                self.edit1.Enable( True )
                self.button1.Enable( True )
        
        if id == self.chk_id4:
            self.edit4.Enable( cbox.IsChecked() )
            self.button4.Enable( cbox.IsChecked() )
            
            if cbox.IsChecked():
                self.check2.SetValue(True)
                self.edit2.Enable( True )
                self.button2.Enable( True )

        if id == self.chk_id5:
            if cbox.IsChecked():
                self.check1.SetValue(True)
                self.edit1.Enable( True )
                self.button1.Enable( True )
                self.check2.SetValue(True)
                self.edit2.Enable( True )
                self.button2.Enable( True )

            self.spin1.Enable( cbox.IsChecked() )
            
    
    def OnButton(self, event):
        idx = event.GetId()

        dlg = wx.DirDialog(self, "Choose a directory:",
                          style=wx.DD_DEFAULT_STYLE|wx.DD_NEW_DIR_BUTTON)
        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
            if idx == 100:
                self.edit1.SetValue(path)
            elif idx == 101:
                self.edit2.SetValue(path)
            elif idx == 102:
                self.edit3.SetValue(path)
            elif idx == 103:
                self.edit4.SetValue(path)
        dlg.Destroy()
        
    def SaveSettings(self):
        import os.path
        self.btconfig.Set("use_download_dir", self.check1.IsChecked())
        self.btconfig.Set("use_torrent_dir", self.check2.IsChecked())
        

        if self.check1.IsChecked():
            self.btconfig.Set("download_dir", self.edit1.GetValue())
        
        if self.check2.IsChecked():
            self.btconfig.Set("torrent_dir", self.edit2.GetValue())
            
        if self.check3.IsChecked():
            self.btconfig.Set("completed_dl_dir", self.edit3.GetValue())
        else:
            self.btconfig.Set("completed_dl_dir", self.edit1.GetValue())
            
        if self.check4.IsChecked():
            self.btconfig.Set("completed_tor_dir", self.edit4.GetValue())
        else:
            self.btconfig.Set("completed_tor_dir", self.edit2.GetValue())
        
        if self.check5.IsChecked():
            self.btconfig.Set("tdir_scan", max(60, self.spin1.GetValue()*60))
        else:
            self.btconfig.Set("tdir_scan", 0)
        
        self.btconfig.UpdateOptions()
        
    
#-----------------------------------------------------------------------------

class Options_Choker_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        
        self.Freeze()
        box = wx.StaticBox(self, -1, "Choker Options", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
       
        choker_select = ["G3 - Customizable strategy",
                         "Standard strategy from BitTorrent 3.4.2",
                         "Leech mode"]
        
        RBOX1 = wx.NewId()
        self.radio1 = wx.RadioBox(self, RBOX1, "Select a predefined choking stratagy:",
                        wx.DefaultPosition, wx.DefaultSize,
                        choker_select, 1, wx.RA_SPECIFY_COLS)
        self.radio1.SetSelection(btconfig.Get('choker'))
        wx.EVT_RADIOBOX(self, RBOX1, self.OnRadio) 
        
        notebox1 = wx.StaticBox(self, -1, "Customize")
        noteboxer1 = wx.StaticBoxSizer(notebox1, wx.VERTICAL)
        triplewide = wx.FlexGridSizer(cols = 3, vgap = 3, hgap = 2)

        self.spin1 = wx.SpinCtrl(self, -1, size = wx.Size(50, Widget_H))
        self.spin1.SetRange(1, 360)
        self.spin1.SetValue(btconfig.Get('choke_period'))

        self.spin2 = wx.SpinCtrl(self, -1, size = wx.Size(50, Widget_H))
        self.spin2.SetRange(1, 1080)
        self.spin2.SetValue(btconfig.Get('opt_choke_period'))

        self.floatctrl = NumCtrl(self, size = (20, Widget_H), 
                groupDigits=False, allowNegative=False, integerWidth=4, fractionWidth=2)
        self.floatctrl.SetBounds(0.00, 9999.99)
        try:
            self.floatctrl.SetValue(btconfig.Get('choke_minrate'))
        except ValueError:
            self.floatctrl.SetValue(0)
            
        
        self.label1 = wx.StaticText(self, -1, "Run choker every")
        self.label2 = wx.StaticText(self, -1, "Rotate optimistic unchoke target every")
        self.label3 = wx.StaticText(self, -1, "Min Upload Rate")
        self.label5 = wx.StaticText(self, -1, "secs")
        self.label6 = wx.StaticText(self, -1, "secs")
        self.label7 = wx.StaticText(self, -1, "KB/s")
        
        triplewide.Add(self.label1, 1, wx.EXPAND)
        triplewide.Add(self.spin1, 1, wx.EXPAND)
        triplewide.Add(self.label5, 1, wx.EXPAND)
        
        triplewide.Add(self.label2, 1, wx.EXPAND)
        triplewide.Add(self.spin2, 1, wx.EXPAND)
        triplewide.Add(self.label6, 1, wx.EXPAND)
        
        triplewide.Add(self.label3, 1, wx.EXPAND)
        triplewide.Add(self.floatctrl, 1, wx.EXPAND)
        triplewide.Add(self.label7, 1, wx.EXPAND)
        
        triplewide.AddGrowableCol(0)
        noteboxer1.Add(triplewide, 1, wx.EXPAND)

        notebox2 = wx.StaticBox(self, -1, "Note")
        noteboxer2 = wx.StaticBoxSizer(notebox2, wx.VERTICAL)
        self.notelabel = wx.StaticText(self, -1, "")
        noteboxer2.Add(self.notelabel, 1, wx.EXPAND)
        
        
        tall.Add((psize[0] - 10,10)) # spacer
        tall.Add(self.radio1, 1, wx.EXPAND)
        tall.Add(noteboxer1, 1, wx.EXPAND)
        tall.Add(noteboxer2, 1, wx.EXPAND)
        
        tall.AddGrowableCol(0)
        tall.AddGrowableRow(3)
        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)        
        self.Layout()
        self.Thaw()
        self.OnSelected(btconfig.Get('choker'))
        

    def OnSelected(self, selection):
        if selection == 0:
            self.notelabel.SetLabel("G3 - "
                                  + "Customizable choker allows advanced control over which pieces get choked\n"
                                  + "\nNote: The Choker is the mechanism that determines which s you will upload to "
                                  + "This choker has the ability to reject (not upload to) "
                                  + "peers who in turn do not meet a MIN upload requirement")
            self.spin1.Enable(True)
            self.spin2.Enable(True)
            self.floatctrl.Enable(True)
        elif selection == 1:
            self.notelabel.SetLabel("Like the G3 Customizable choker, this algorithm attempts to keep connections open to the best "
                                  + "connections (based who currently has the highest upload rate) by giving them upload preference. One new connection is "
                                  + "optimistically picked from a queue and unchoked in the hope they will "
                                  + "reciprocate.\nFriend/Foe functionaly will not work in this mode"
                                  )
            self.spin1.SetValue(10)
            self.spin2.SetValue(30)
            self.floatctrl.SetValue(0)
            self.spin1.Enable(False)
            self.spin2.Enable(False)
            self.floatctrl.Enable(False)
        elif selection == 2:
            self.notelabel.SetLabel("Not recomended\n\n"
                                 +  "Expect VERY poor download performance in this mode "
                                 +  "as other clients will not be very interested in uploading to you if you don't upload. "
                                 +  "Only for people who can't spare any upload bandwidth")
            self.spin1.SetValue(10)
            self.spin2.SetValue(30)
            self.floatctrl.SetValue(0)
            self.spin1.Enable(False)
            self.spin2.Enable(False)
            self.floatctrl.Enable(False)
        self.Layout()
        
    def OnRadio(self, event):
        self.OnSelected(event.GetSelection())
            
    def SaveSettings(self):
        if self.radio1.GetSelection() == 2:
            msg = 'Warning: The mode you selected disables uploads completely.\n' \
                    + 'In most cases this will serverly lower your download potential.'
            dlg = wx.MessageDialog(self, msg, "Here's a clue", wx.OK | wx.ICON_INFORMATION)
            dlg.ShowModal()
            dlg.Destroy()
                          
        self.btconfig.Set('choker', self.radio1.GetSelection())
        if self.spin1.GetValue() < 360 and self.spin1.GetValue() > 0:
            self.btconfig.Set('choke_period', self.spin1.GetValue())
        if self.spin2.GetValue() < 1080 and self.spin2.GetValue() > 0:
            self.btconfig.Set('opt_choke_period', self.spin2.GetValue())
        self.btconfig.Set('choke_minrate', self.floatctrl.GetValue())
        self.btconfig.UpdateOptions()
    
#-----------------------------------------------------------------------------

class Options_Net_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        

        # Controls
        label1 = wx.StaticText(self, -1, "Minimum port:")
        label2 = wx.StaticText(self, -1, "Maximum port:")
        label3 = wx.StaticText(self, -1, "IP to bind to locally:")
        label4 = wx.StaticText(self, -1, "IP to report to tracker:")
        
        label5 = wx.StaticText(self, -1, "Download capacity:")
        label6 = wx.StaticText(self, -1, "Upload capacity:")
        notelabel = wx.StaticText(self, -1, "Download/Upload capacity values "
                + "are only used to determine limits for the graphs. "
                + "To set an actual upload rate limit, go to Transfer Options\n\n"
                + "Do not enter anything where it says \"IP to bind to locally\" "
                + "unless you know exactly what you are doing"
                )

        self.ip_field1 = IpAddrCtrl(self, -1, style = wx.TE_PROCESS_TAB)
        if btconfig.Get('bind_address') != None:
            self.ip_field1.SetValue(btconfig.Get('bind_address'))
        
        tt = wx.ToolTip("Leave this field empty unless you have special needs")
        self.ip_field1.SetToolTip(tt)
        
        self.ip_field2 = IpAddrCtrl(self, -1, style = wx.TE_PROCESS_TAB)
        if btconfig.Get('ip_2report') != None:
            self.ip_field2.SetValue(btconfig.Get('ip_2report'))
        
        tt = wx.ToolTip("Leave this field empty unless you have special needs")
        self.ip_field2.SetToolTip(tt)
        
        self.spin1 = wx.SpinCtrl(self, -1, size = wx.Size(80, Widget_H))
        self.spin1.SetRange(0, 65535)
        self.spin1.SetValue(btconfig.Get('minport'))
        
        self.spin2 = wx.SpinCtrl(self, -1, size = wx.Size(80, Widget_H))
        self.spin2.SetRange(0, 65535)
        self.spin2.SetValue(btconfig.Get('maxport'))

        self.spin3 = wx.SpinCtrl(self, -1, size = wx.Size(80, Widget_H))
        self.spin3.SetRange(0, 65535)
        self.spin3.SetValue(btconfig.Get('net_max_downrate') / 1024 )

        self.spin4 = wx.SpinCtrl(self, -1, size = wx.Size(80, Widget_H))
        self.spin4.SetRange(0, 65535)
        self.spin4.SetValue(btconfig.Get('net_max_uprate') / 1024 )

        # Sizers
        box = wx.StaticBox(self, -1, "Network Options", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 2)
        double1 = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 2)
        rateboxer = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 2)
        capbox = wx.StaticBox(self, -1, "Transfer Rate")
        capboxer = wx.StaticBoxSizer(capbox, wx.VERTICAL)
        portbox = wx.StaticBox(self, -1, "Port Range")
        portboxer = wx.StaticBoxSizer(portbox, wx.VERTICAL)
        notebox = wx.StaticBox(self, -1, "Note")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
        
        double.AddGrowableCol(0)
        double1.AddGrowableCol(0)
        tall.AddGrowableCol(0)
        tall.AddGrowableRow(7)
        
        rateboxer.Add(label5, 1, wx.EXPAND)
        rateboxer.Add(self.spin3, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        rateboxer.Add(label6, 1, wx.EXPAND)
        rateboxer.Add(self.spin4, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        rateboxer.AddGrowableCol(0)
        capboxer.Add(rateboxer, 1, wx.EXPAND)
        
        double1.Add(label3, 1, wx.EXPAND)
        double1.Add(self.ip_field1, 1, wx.EXPAND)
        
        double1.Add(label4, 1, wx.EXPAND)
        double1.Add(self.ip_field2, 1, wx.EXPAND)
        
        
        portboxer.Add(double, 1, wx.EXPAND)

        double.Add(label1, 1, wx.EXPAND) 
        double.Add(self.spin1, 1, wx.EXPAND | wx.ALIGN_RIGHT) 
        double.Add(label2, 1, wx.EXPAND) 
        double.Add(self.spin2, 1, wx.EXPAND | wx.ALIGN_RIGHT) 
        
        noteboxer.Add(notelabel, 1, wx.EXPAND)
        
        tall.Add((10,10)) # spacer
        tall.Add(capboxer, 1, wx.EXPAND)
        tall.Add((10,10)) # spacer
        tall.Add(portboxer, 1, wx.EXPAND)
        tall.Add((10,10)) # spacer
        tall.Add(double1, 1, wx.EXPAND)
        tall.Add((10,10)) # spacer
        tall.Add(noteboxer, 1, wx.EXPAND)

        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()

    def SaveSettings(self):
        self.btconfig.Set('minport', self.spin1.GetValue())
        self.btconfig.Set('maxport', self.spin2.GetValue())
        self.btconfig.Set('net_max_downrate', self.spin3.GetValue() * 1024)
        self.btconfig.Set('net_max_uprate', self.spin4.GetValue() * 1024)
        
        if self.ip_field1.GetPlainValue() == "" or not self.ip_field1.IsValid():
            self.btconfig.Set('bind_address', None)
        else:
            self.btconfig.Set('bind_address', self.ip_field1.GetValue())
            
        if self.ip_field2.GetPlainValue() == "" or not self.ip_field2.IsValid():
            self.btconfig.Set('ip_2report', None)
        else:
            ip = self.ip_field2.GetValue().replace(' ','')
            self.btconfig.Set('ip_2report', ip)

        self.btconfig.UpdateOptions()

#-----------------------------------------------------------------------------

class Options_WebI_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        

        # Controls
        self.check1 = wx.CheckBox(self, -1, "Enable Web Interface")
        self.check1.SetValue( btconfig['use_web_interface'] )

        label1 = wx.StaticText(self, -1, "Password:")
        self.edit1  = wx.TextCtrl(self, -1, "", style=wx.TE_PASSWORD)
        try:
            self.edit1.SetValue( btconfig['web_interface_pass'] )
        except TypeError:
            self.edit1.SetValue("password")
        
        try:
            self.myip = socket.gethostbyaddr(socket.gethostname())[2][0]
        except socket.error:
            self.myip = "127.0.0.1"
        
        notelabel = wx.StaticText(self, -1, "The Web Interface allows you to "
                + "view progress and status of your torrent downloads from "
                + "a remote location. It also gives you the ability to start, stop "
                + "and add new torrents remotely.\n\n"
                + "If you choose to have it running, you can connect to it from "
                + "your browser at:"
                )
        
        self.addrlabel = wx.StaticText(self, -1, "http://%s:7007/" % self.myip)
        self.addrlabel.SetForegroundColour('Blue')
        wx.EVT_LEFT_DOWN(self.addrlabel, self.OnUrlClick)

        # Sizers
        box = wx.StaticBox(self, -1, "Web Interface", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 2)
        optbox = wx.StaticBox(self, -1, "Options")
        optboxer = wx.StaticBoxSizer(optbox, wx.VERTICAL)
        notebox = wx.StaticBox(self, -1, "Note")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
               
        tall.AddGrowableCol(0)
        tall.AddGrowableRow(5)
        double.AddGrowableCol(1)
        
        double.Add(label1, 1, wx.EXPAND |wx.NORTH, 4)
        double.Add(self.edit1, 1, wx.EXPAND)
        optboxer.Add(double, 1, wx.EXPAND)
        noteboxer.Add(notelabel, 1, wx.EXPAND)
        noteboxer.Add(self.addrlabel, 1, wx.EXPAND)
        
        tall.Add((10,10)) # spacer
        tall.Add(self.check1, 1, wx.EXPAND)
        tall.Add((10,10)) # spacer
        tall.Add(optboxer, 1, wx.EXPAND)
        tall.Add((10,10)) # spacer
        tall.Add(noteboxer, 1, wx.EXPAND)

        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()

    def _OpenUrl(self):
        try:
            open_new(self.addrlabel.GetLabel())
        except:
            pass

            
    def OnUrlClick(self, event):
        Thread(target = self._OpenUrl).start()
        
    def SaveSettings(self):
        self.btconfig.Set('use_web_interface', self.check1.GetValue())
        self.btconfig.Set('web_interface_pass', self.edit1.GetValue().encode(locale.getpreferredencoding()))

        self.btconfig.UpdateOptions()
            
#-----------------------------------------------------------------------------


class Options_Error_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        
        
        label1 = wx.StaticText(self, -1, "Ban peer after N bad pieces:")
        label2 = wx.StaticText(self, -1, "Auto Pause Torrent after N failures:")
        notelabel = wx.StaticText(self, -1, "Occasionally, Peers will "
            "send pieces that fail the hash check and must be downloaded agan.\n"
            "Even good peers have been known to occasionally send a bad piece or two."
            "Don't set this value too low if you want to avoid banning helpfull peers\n\n"
            "Torrents will get paused automatically if they cannot connect to "
            "to the tracker. But only if it is not currently connected to peers and is"
            "transfering data\n\n" 
            )
            
        
        self.spin1 = wx.SpinCtrl(self, -1, size = wx.Size(50, Widget_H))
        self.spin1.SetRange(1, 999)
        self.spin1.SetValue(btconfig.Get('max_hashflunks'))
        
        self.spin2 = wx.SpinCtrl(self, -1, size = wx.Size(50, Widget_H))
        self.spin2.SetRange(1, 999)
        self.spin2.SetValue(btconfig.Get('max_trkrflunks'))

        box = wx.StaticBox(self, -1, "Error Options", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 2)

        notebox = wx.StaticBox(self, -1, "Note")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
        noteboxer.Add(notelabel, 1, wx.EXPAND)
        
        double.AddGrowableCol(0)
        double.Add(label1, 1, wx.EXPAND) 
        double.Add(self.spin1, 1, wx.EXPAND | wx.ALIGN_RIGHT) 
        double.Add(label2, 1, wx.EXPAND) 
        double.Add(self.spin2, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        
        tall.AddGrowableCol(0)
        tall.AddGrowableRow(3)
        tall.Add((10,10)) # spacer
        tall.Add(double, 1, wx.EXPAND | wx.ALL)
        tall.Add((10,10)) # spacer
        tall.Add(noteboxer, 1, wx.EXPAND)
        
        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()

    def SaveSettings(self):
        self.btconfig.Set('max_hashflunks', self.spin1.GetValue())
        self.btconfig.Set('max_trkrflunks', self.spin2.GetValue())
        self.btconfig.UpdateOptions()
    
#------------------------------------------------------------------------------

class Options_OnFin_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        
        box = wx.StaticBox(self, -1, "On Completion", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 2)

        after_dl = ["Keep sharing, unless downloads are in queue",
                    "Keep sharing, until custom condition is met",
                    "Keep sharing",
                    "Stop sharing"]
        
        RBOX1 = wx.NewId()
        self.radio1 = wx.RadioBox(self, RBOX1, "When a download completes:",
                        wx.DefaultPosition, wx.DefaultSize,
                        after_dl, 1, wx.RA_SPECIFY_COLS)
        self.radio1.SetSelection(btconfig.Get('on_complete'))
        wx.EVT_RADIOBOX(self, RBOX1, self.OnRadio)

        self.check1 = wx.CheckBox(self, -1, "Upload till I have uploaded N%")
        self.check2 = wx.CheckBox(self, -1, "Upload till bytes down:up ratio")
        self.check3 = wx.CheckBox(self, -1, "Only upload for another Hours:Mins")

        self.edit1 = TextCtrl(self, -1, '100', mask='###%', formatcodes='r>', size=(50,Widget_H))
        self.edit2 = TextCtrl(self, -1, '1:2', mask='1:##', formatcodes='r>', size=(50,Widget_H))
        self.edit3 = TextCtrl(self, -1, '00:00', mask='##:##', formatcodes='r>', size=(50,Widget_H))

        self.check4 = wx.CheckBox(self, -1, "Upload at this new rate (KB/s)")
        self.spin1 = wx.SpinCtrl(self, -1, size = wx.Size(70, Widget_H))
        self.spin1.SetRange(0, 10000)

        self.spin1.SetValue(btconfig.Get('end_newrate')/1024)
        self.check1.SetValue(btconfig.Get('end_on_percent'))
        self.check2.SetValue(btconfig.Get('end_on_ratio'))
        self.check3.SetValue(btconfig.Get('end_on_timelimit'))
        self.check4.SetValue(btconfig.Get('end_on_newrate'))
        
        end_ratio = btconfig.Get('end_ratio')
        end_percent = btconfig.Get('end_percent')
        end_timelimit = btconfig.Get('end_timelimit')

        try:
            self.edit1.SetValue("%d" % int(100*end_percent))
            self.edit2.SetValue("1:%d" % end_ratio)
            self.edit3.SetValue("%s" % strftime("%H:%M", gmtime(end_timelimit)))
        except:
            print_exc()
            print "ERROR: could not set values"

        self.custbox = wx.StaticBox(self, -1, "Custom Condition")
        custboxer = wx.StaticBoxSizer(self.custbox, wx.VERTICAL)
        custboxer.Add(double, 1, wx.EXPAND)
        self.custboxer = custboxer

        self.OnSelected(self.radio1.GetSelection())
        
        double.Add((-1,5))
        double.Add((-1,5))
        double.Add(self.check1, 1, wx.EXPAND)
        double.Add(self.edit1, 1)
        double.Add(self.check2, 1, wx.EXPAND)
        double.Add(self.edit2, 1)
        double.Add(self.check3, 1, wx.EXPAND)
        double.Add(self.edit3, 1)
        
        double.Add(self.check4, 1, wx.EXPAND)
        double.Add(self.spin1, 1)
        double.AddGrowableCol(0)

        notebox = wx.StaticBox(self, -1, "Note")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
        label5 = wx.StaticText(self, -1, "Try to keep files seeded as long as possible. "
                                + "This is what Brian Boitano would do")
        noteboxer.Add(label5, 1, wx.EXPAND)

        tall.Add((0,5)) # spacer
        tall.Add(self.radio1, 1, wx.EXPAND)
        tall.Add(custboxer, 1, wx.EXPAND)
        tall.Add(noteboxer, 1, wx.EXPAND)
        tall.AddGrowableRow(3)
        
        tall.AddGrowableCol(0)
        self.tall = tall
        
        boxer.Add(tall, 1, flag = wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()
        
    def ToggleCustBox(self, value):
        self.custbox.Enable(value)
        self.check1.Enable(value)
        self.check2.Enable(value)
        self.check3.Enable(value)
        self.edit1.Enable(value)
        self.edit2.Enable(value)
        self.edit3.Enable(value)
        self.check4.Enable(value)
        self.spin1.Enable(value)
        
    def OnSelected(self, selection):
        if selection == 1:
            self.ToggleCustBox(True)
        else:
            self.ToggleCustBox(False)
    
    def OnRadio(self, event):
        self.OnSelected(event.GetSelection())
        
    def SaveSettings(self):
        self.btconfig.Set('on_complete', self.radio1.GetSelection())
        
        self.btconfig.Set('end_on_percent', self.check1.GetValue())
        self.btconfig.Set('end_on_ratio', self.check2.GetValue())
        self.btconfig.Set('end_on_timelimit', self.check3.GetValue())
        self.btconfig.Set('end_on_newrate', self.check4.GetValue())
                
        #this is moronic... but some users perfer ratio others percent
        ratio1 = self.edit1.GetValue() 
        ratio1 = float( ratio1[:len(ratio1)-1] ) / 100
        ratio2 = int( self.edit2.GetValue()[2:] )

        try:
            timelimit = int(self.edit3.GetValue()[:2])*3600 + int(self.edit3.GetValue()[3:])*60
            self.btconfig.Set('end_timelimit', timelimit)       
        except ValueError:
            pass
        
        self.btconfig.Set('end_percent', ratio1)
        self.btconfig.Set('end_ratio', ratio2)
        self.btconfig.Set('end_newrate', self.spin1.GetValue()*1024)

        self.btconfig.UpdateOptions()
    
#-----------------------------------------------------------------------------

class Options_Gen_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        
        box = wx.StaticBox(self, -1, "General", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 20)
        
        
        label0 = wx.StaticText(self, -1, "Nickname (max length 9):")
        self.nameedit = wx.TextCtrl(self, -1, "", size=(80, -1))
        try:
            self.nameedit.SetValue(unicode(self.btconfig.Get('nickname')))
        except:
            self.nameedit.SetValue('Anonymous')
            # DEBUG: I think some non english names are crashing the options
            print_exc()
        
        label3 = wx.StaticText(self, -1, "Min simultaneous torrents:")
        self.spin1 = wx.SpinCtrl(self, -1, size = wx.Size(50, Widget_H))
        self.spin1.SetRange(0, 100)
        self.spin1.SetValue(btconfig.Get('max_sessions'))
        
        label8 = wx.StaticText(self, -1, "Update GUI every:")
        
        self.combo1 = wx.ComboBox(self, -1, size = wx.Size(50, Widget_H),
                choices=["500 ms", "1000 ms", "1500 ms", "2000 ms", "5000 ms"],
                style=wx.CB_READONLY)
        self.combo1.SetValue( "%d ms" % (btconfig.Get('gui_update_rate')*1000) )
        
        label1 = wx.StaticText(self, -1, "Popup error messages:")
        self.check1 = wx.CheckBox(self, 100, "", wx.Point(100, 0), wx.Size(150, 20), wx.NO_BORDER)
        self.check1.SetValue(btconfig.Get('popup_errors'))
        
        label2 = wx.StaticText(self, -1, "Load completed torrents on start:")
        self.check2 = wx.CheckBox(self, 101, "", wx.Point(100, 0), wx.Size(150, 20), wx.NO_BORDER)
        self.check2.SetValue(btconfig.Get('load_completed'))

        label6 = wx.StaticText(self, -1, "Minimize to system tray:")
        self.check3 = wx.CheckBox(self, 101, "", wx.Point(100, 0), wx.Size(150, 20), wx.NO_BORDER)
        self.check3.SetValue(btconfig.Get('usesystray'))

        label7 = wx.StaticText(self, -1, "Confirmation on exit:")
        self.check4 = wx.CheckBox(self, 101, "", wx.Point(100, 0), wx.Size(150, 20), wx.NO_BORDER)
        self.check4.SetValue(btconfig.Get('confirmexit'))
                        
        label9 = wx.StaticText(self, -1, "Skip hash check on 100% files:")
        self.check5 = wx.CheckBox(self, 101, "", wx.Point(100, 0), wx.Size(150, 20), wx.NO_BORDER)
        self.check5.SetValue(not btconfig.Get('always_check_hashes'))        
        
        label4 = wx.StaticText(self, -1, "Associate with .torrent files:")
        b_id = wx.NewId()
        ass_butt = wx.Button(self, b_id, "Associate")
        

        notebox = wx.StaticBox(self, -1, "Note")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
        label5 = wx.StaticText(self, -1, "The Min simultaneous torrents setting "
                                + "sets a limit on the number of torrents the "
                                + "client will automatically start. This will not "
                                + "limit the number of torrents a user can manually start\n"
                                + "Your nickname can only been seen by those using the G3 Torrent client")
        noteboxer.Add(label5, 1, wx.EXPAND)
        
        
        double.Add(label0, 1, wx.EXPAND)
        double.Add(self.nameedit, 1, wx.EXPAND)
                
        double.Add(label3, 1, wx.EXPAND)
        double.Add(self.spin1, 1, wx.EXPAND | wx.ALIGN_RIGHT)

        double.Add(label8, 1, wx.EXPAND)
        double.Add(self.combo1, 1, wx.EXPAND | wx.ALIGN_RIGHT)

        double.Add(label1, 1, wx.EXPAND)
        double.Add(self.check1, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        
        double.Add(label2, 1, wx.EXPAND)
        double.Add(self.check2, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        
        double.Add(label6, 1, wx.EXPAND)
        double.Add(self.check3, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        
        double.Add(label7, 1, wx.EXPAND)
        double.Add(self.check4, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        
        double.Add(label9, 1, wx.EXPAND)
        double.Add(self.check5, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        
        double.Add(label4, 1, wx.EXPAND)
        double.Add(ass_butt, 1, wx.EXPAND | wx.ALIGN_RIGHT)
        
        double.AddGrowableCol(0)

        tall.Add((0,5)) # spacer
        tall.Add(double, 1, wx.EXPAND | wx.ALL, 4) # spacer
        tall.Add((0,5)) # spacer
        tall.Add(noteboxer, 1, wx.EXPAND)
        tall.AddGrowableRow(3)
        
        
        tall.AddGrowableCol(0)        
        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()

        wx.EVT_BUTTON(self, b_id, self.Register)
        

    def Register(self, event):
        if sys.platform != "win32":
            return
            
        print "Attempting register"
        path = self.btconfig.Get('path')
        exe_name = join(path, 'g3torrent.exe')
        print exe_name
        
        reg_str = [
                    [ HKEY_CLASSES_ROOT, ".torrent", "", "bittorrent", 0 ],
                    [ HKEY_CLASSES_ROOT, ".torrent", "Content Type", "application/x-bittorrent", 0 ],
                    [ HKEY_CLASSES_ROOT, "MIME\\Database\\Content Type\\application/x-bittorrent", "Extension", ".torrent", 0 ],
                    [ HKEY_CLASSES_ROOT, "bittorrent", "", "TORRENT File", 0 ],
                    [ HKEY_CLASSES_ROOT, "bittorrent", "EditFlags", "\0\0\0\0\0\1\0\0", 1 ],
                    [ HKEY_CLASSES_ROOT, "bittorrent\\shell", "", "open", 0 ],
                    [ HKEY_CLASSES_ROOT, "bittorrent\\shell\\open\\command", "", ('"%s"' % exe_name) + '--responsefile "%1"', 0 ]
                ]

        for key in reg_str:
            try:
                print 'opening'
                reg = OpenKey(key[0], key[1], 0, KEY_SET_VALUE)
            except EnvironmentError:
                print 'creating'
                try:
                    reg = CreateKey(key[0], key[1])
                except:
                    print "Unable to create key!" + "key[0]" + key[1]
                    return

            if key[4] == 0:
                SetValue(reg, key[2], REG_SZ, key[3])
            elif key[4] == 1:
                SetValueEx(reg, key[2], 0, REG_BINARY, key[3])
                
            CloseKey(reg)

        print "registered!" 
        
        
    def SaveSettings(self):
        self.btconfig.Set('max_sessions', self.spin1.GetValue())
        self.btconfig.Set('popup_errors', self.check1.GetValue())
        self.btconfig.Set('load_completed', self.check2.GetValue())
        self.btconfig.Set('usesystray', self.check3.GetValue())
        self.btconfig.Set('confirmexit', self.check4.GetValue())
        self.btconfig.Set('always_check_hashes', not self.check5.GetValue())
        
        name = self.nameedit.GetValue()
        self.btconfig.Set('nickname', name[:9])
        
        update_rate = self.combo1.GetValue()
        if update_rate == '500 ms':
            self.btconfig.Set('gui_update_rate', 0.50)
        elif update_rate == '1000 ms':
            self.btconfig.Set('gui_update_rate', 1)
        elif update_rate == '1500 ms':
            self.btconfig.Set('gui_update_rate', 1.5)
        elif update_rate == '2000 ms':
            self.btconfig.Set('gui_update_rate', 2)
        elif update_rate == '5000 ms':
            self.btconfig.Set('gui_update_rate', 5)
            
            
        self.btconfig.UpdateOptions()        
    
#-----------------------------------------------------------------------------

class Options_PL_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        
        box = wx.StaticBox(self, -1, "Default Peer List Options", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 20)

        self.check1 = wx.CheckBox(self, 100, "  Keep Sorted", wx.DefaultPosition, wx.Size(-1, Widget_H), wx.NO_BORDER)
        self.check1.SetValue(btconfig.Get('sort_list'))

        self.check2 = wx.CheckBox(self, 100, "  Reverse DNS", wx.DefaultPosition, wx.Size(-1, Widget_H), wx.NO_BORDER)
        self.check2.SetValue(btconfig.Get('reverse_dns'))
 
        self.check3 = wx.CheckBox(self, 100, "  Show Country Flags", wx.DefaultPosition, wx.Size(-1, Widget_H), wx.NO_BORDER)
        self.check3.SetValue(btconfig.Get('country_flags'))
        
        notebox = wx.StaticBox(self, -1, "Note")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
        label5 = wx.StaticText(self, -1, "The 'Keep Sorted' option incures a small cpu hit "
                                         "because it tends to keep the list constantly in motion.")
        noteboxer.Add(label5, 1, wx.EXPAND)
        

        double.AddGrowableCol(1)        
        double.Add(self.check1, 1, wx.EXPAND)
        double.Add(self.check2, 1, wx.EXPAND)
        double.Add(self.check3, 1, wx.EXPAND)

        tall.AddGrowableCol(0)
        tall.Add((0,5)) # spacer
        tall.Add(double, 1, wx.EXPAND | wx.ALL, 4) # spacer
        tall.Add((0,5)) # spacer
        tall.Add(noteboxer, 1, wx.EXPAND)
        tall.AddGrowableRow(3)
   
        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()
    
 
    def SaveSettings(self):
        self.btconfig.Set('sort_list', self.check1.GetValue())
        self.btconfig.Set('reverse_dns',  self.check2.GetValue())
        self.btconfig.Set('country_flags', self.check3.GetValue())
        self.btconfig.UpdateOptions()
    
#-----------------------------------------------------------------------------

class Options_Conn_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig
                
        label1 = wx.StaticText(self, -1, "Max Connections - Total:")
        label2 = wx.StaticText(self, -1, "Max Connections - Local (Outbound):")
        label3 = wx.StaticText(self, -1, "Drop Leechers:")
        
        self.spin1 = wx.SpinCtrl(self, -1, size = wx.Size(70, Widget_H))
        self.spin1.SetRange(0, 1000)
        try:
            self.spin1.SetValue(self.btconfig.Get('max_connections'))
        except:
            self.spin1.SetValue(55)
            
        self.spin2 = wx.SpinCtrl(self, -1, size = wx.Size(70, Widget_H))
        self.spin2.SetRange(0, 1000)
        try:
            self.spin2.SetValue(self.btconfig.Get('max_initiate'))
        except:
            self.spin1.SetValue(35)
        
        self.check1 = wx.CheckBox(self, -1, "", size = wx.Size(70, Widget_H))
        if self.btconfig['drop_leechers']:
            self.check1.SetValue(True)
        
        box = wx.StaticBox(self, -1, "Connection Options", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double1 = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 2)
        connsbox = wx.StaticBox(self, -1, "Max Connections Per Torrent")
        connsboxer = wx.StaticBoxSizer(connsbox, wx.HORIZONTAL)
        double1.AddGrowableCol(0)
        tall.AddGrowableCol(0)
        tall.AddGrowableRow(2)
        
        double1.Add(label1, 1, wx.ALIGN_LEFT)
        double1.Add(self.spin1, 1, wx.ALIGN_RIGHT)
        double1.Add(label2, 1, wx.ALIGN_LEFT)
        double1.Add(self.spin2, 1, wx.ALIGN_RIGHT)
        double1.Add(label3, 1, wx.ALIGN_LEFT)
        double1.Add(self.check1 , 1, wx.ALIGN_RIGHT)
        
        
        connsboxer.Add(double1, 1, wx.EXPAND)

        notebox = wx.StaticBox(self, -1, "Note")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
        label5 = wx.StaticText(self, -1, \
                  "Max Connections - Total is number of connections to allow total\n\n" \
                + "Max Local Connections is the number of connection the client " \
                + "will open locally. Remote connections will still be accepted "
                + "untill Max Connections - Total is reached.\n\n"
                + "Drop Leechers: The client will automatically disconnect peers who don't appear to be contributing. Default rule: Drop anyone with a share ratio worse than 4:1 after 20mins\n\n"
                )
        noteboxer.Add(label5, 1, wx.EXPAND)
        
        tall.Add((-1,5)) # spacer
        tall.Add(connsboxer, 1, wx.EXPAND)
        tall.Add(noteboxer, 1, wx.EXPAND)
        boxer.Add(tall, 1, wx.EXPAND)
        
        self.SetSizer(boxer)
        self.Layout()

    def SaveSettings(self):
        self.btconfig.Set('max_connections', self.spin1.GetValue())
        self.btconfig.Set('max_initiate', self.spin2.GetValue())
        self.btconfig.Set('drop_leechers', self.check1.GetValue())
        self.btconfig.UpdateOptions()
        
#------------------------------------------------------------------------------

class Options_Rate_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig
                
        chk_Id1 = wx.NewId()
        self.check1 = wx.CheckBox(self, chk_Id1, "Use a global setting", wx.Point(0, 0), wx.Size(-1, Widget_H), wx.NO_BORDER)
        self.check1.SetValue(btconfig.Get('use_global_urate'))
        wx.EVT_CHECKBOX(self, chk_Id1, self.OnCheck)

        label4 = wx.StaticText(self, -1, "Global Max Upload Rate (KB/s):")
        label5 = wx.StaticText(self, -1, "Avg Upload Rate per peer (KB/s):")
        self.spin4 = wx.SpinCtrl(self, -1, size = wx.Size(70, Widget_H))
        self.spin4.SetRange(0, 100000)
        self.spin4.SetValue(self.btconfig.Get('total_max_uprate')/1024)
        self.spin5 = wx.SpinCtrl(self, -1, size = wx.Size(70, Widget_H))
        self.spin5.SetRange(0, 1000)
        self.spin5.SetValue(self.btconfig.Get('avg_peer_urate'))
        
        label1 = wx.StaticText(self, -1, "Max Upload Rate (KB/s):")
        label2 = wx.StaticText(self, -1, "Max Uploads:")
        
        self.spin1 = wx.SpinCtrl(self, -1, size = wx.Size(70, Widget_H))
        self.spin1.SetRange(0, 100000)
        self.spin1.SetValue(self.btconfig.Get('maxupspeed'))

        self.spin2 = wx.SpinCtrl(self, -1, size = wx.Size(70, Widget_H))
        self.spin2.SetRange(0, 10000)
        self.spin2.SetValue(self.btconfig.Get('maxuploads'))        

        box = wx.StaticBox(self, -1, "Rate Options", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        double1 = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 2)
        double2 = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 2)
        globalbox = wx.StaticBox(self, -1, "Global torrent options")
        globalboxer = wx.StaticBoxSizer(globalbox, wx.HORIZONTAL)
        sessionbox = wx.StaticBox(self, -1, "Per torrent options")
        sessionboxer = wx.StaticBoxSizer(sessionbox, wx.HORIZONTAL)
        double1.AddGrowableCol(0)
        double2.AddGrowableCol(0)
        tall.AddGrowableCol(0)
        tall.AddGrowableRow(5)
        
        double1.Add(label4, 1, wx.ALIGN_LEFT)
        double1.Add(self.spin4, 1, wx.ALIGN_RIGHT)
        double1.Add(label5, 1, wx.ALIGN_LEFT)
        double1.Add(self.spin5, 1, wx.ALIGN_RIGHT)
        globalboxer.Add(double1, 1, wx.EXPAND)
        
        
        double2.Add(label1, 1, wx.ALIGN_LEFT)
        double2.Add(self.spin1, 1, wx.ALIGN_RIGHT)
        double2.Add(label2, 1, wx.ALIGN_LEFT)
        double2.Add(self.spin2, 1, wx.ALIGN_RIGHT)
        sessionboxer.Add(double2, 1, wx.EXPAND)


        notebox = wx.StaticBox(self, -1, "Note")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
        label5 = wx.StaticText(self, -1, "You can select between a global total upload speed, or a unique setting for a particular torrent\n\n"
                                       + "Upload Rate of 0 = unlimited\n"
                                       + "Leave the Upload Rate at 0 or as high as possible for best results\n\n"
                                       )
        noteboxer.Add(label5, 1, wx.EXPAND)
        
        tall.Add((-1,5)) # spacer
        tall.Add(self.check1) # spacer
        tall.Add((-1,5)) # spacer
        tall.Add(globalboxer, 1, wx.EXPAND)
        tall.Add(sessionboxer, 1, wx.EXPAND)
        tall.Add(noteboxer, 1, wx.EXPAND)
        boxer.Add(tall, 1, wx.EXPAND)
        
        self.OnCheck(self.check1)
        self.SetSizer(boxer)
        self.Layout()
        

    def OnCheck(self, event):
        if not event.IsChecked():
            self.spin4.Enable(False)
            self.spin5.Enable(False)
            self.spin1.Enable(True)
            self.spin2.Enable(True)
        else:
            self.spin5.Enable(True)
            self.spin4.Enable(True)
            self.spin1.Enable(False)
            self.spin2.Enable(False)
            

    def SaveSettings(self):
        self.btconfig.Set('maxupspeed', self.spin1.GetValue())
        self.btconfig.Set('maxuploads', self.spin2.GetValue())
        
        self.btconfig.Set('use_global_urate', self.check1.GetValue())
        self.btconfig.Set('total_max_uprate', self.spin4.GetValue() * 1024)
        self.btconfig.Set('avg_peer_urate', self.spin5.GetValue())

        self.btconfig.UpdateOptions()

#---------------------------------------------------------------------------

class Options_LVC_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        
        box = wx.StaticBox(self, -1, "Main List View", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        sizer = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 10)

        notebox = wx.StaticBox(self, -1, "Color Settings")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
        tall.Add((-1,10)) # spacer
        noteboxer.Add((-1,5))
        noteboxer.Add(sizer, 1, wx.EXPAND)
        
        labels = [0] * 6
        labels[0] = wx.StaticText(self, -1, "  Checking:")
        labels[1] = wx.StaticText(self, -1, "  Complete:")
        labels[2] = wx.StaticText(self, -1, "  Seeding:")
        labels[3] = wx.StaticText(self, -1, "  Paused:")
        labels[4] = wx.StaticText(self, -1, "  Stopped:")
        labels[5] = wx.StaticText(self, -1, "  Downloading:")
        
        colors = [
                    'ml_checking',
                    'ml_complete',
                    'ml_seeding',
                    'ml_paused',
                    'ml_stopped',
                    'ml_downloading',
                ]
        
        self.buttons = []
        i = 0
        for i in range(len(labels)):
            b_id = wx.NewId()
            butt = wx.Button(self, b_id, "")
            butt.SetBackgroundColour(self.btconfig.g_colors[colors[i]])
            b = [b_id, butt, colors[i]] 
            self.buttons.append(b)

            sizer.Add(labels[i], 1, wx.EXPAND | wx.ALIGN_LEFT)
            sizer.Add(b[1], 1, wx.ALIGN_RIGHT)
            wx.EVT_BUTTON(self, b[0], self.ChangeColor)
         
        resetButton = wx.Button(self, -1, "Reset to defaults")
        resetButton.Disable()
        sizer.Add(resetButton, 1)
        tall.AddGrowableCol(0)
        sizer.AddGrowableCol(0)
        sizer.AddGrowableCol(1)        
        
        tall.Add(noteboxer, 1, wx.EXPAND)
        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()

    def GetColor(self, color = wx.Color(0,0,0)):
        data = None
        c_dlg = wx.ColourDialog(self)
        c_dlg.GetColourData().SetChooseFull(True)
        c_dlg.GetColourData().SetColour(color)
        if c_dlg.ShowModal() == wx.ID_OK:
            data = c_dlg.GetColourData()
        c_dlg.Destroy()
        if data != None:
            return data.GetColour()
        else:
            return None
    
    def ChangeColor(self, event):
        for b in self.buttons:
            if b[0] == event.GetId():
                current_color = b[1].GetBackgroundColour()
                color = self.GetColor(current_color)
                if color != None:
                    b[1].SetBackgroundColour(color)
                    self.btconfig.g_colors[ b[2] ] = color
                break
        
    def SaveSettings(self):
        self.btconfig.UpdateOptions()

#---------------------------------------------------------------------------
        
class Options_GRAPH_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        
        box = wx.StaticBox(self, -1, "Graph", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        sizer = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 10)

        notebox = wx.StaticBox(self, -1, "Color Settings")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
        tall.Add((-1,10)) # spacer
        noteboxer.Add((-1,5))
        noteboxer.Add(sizer, 1, wx.EXPAND)
        
        labels = [0] * 8
        labels[0] = wx.StaticText(self, -1, "  Background:")
        labels[1] = wx.StaticText(self, -1, "  Graph area foreground:")
        labels[2] = wx.StaticText(self, -1, "  Graph area background:")
        labels[3] = wx.StaticText(self, -1, "  Grid lines:")
        labels[4] = wx.StaticText(self, -1, "  Total Down Rate:")
        labels[5] = wx.StaticText(self, -1, "  Total Up Rate:")
        labels[6] = wx.StaticText(self, -1, "  Selected Down Rate:")
        labels[7] = wx.StaticText(self, -1, "  Selected Up Rate:")
        
        colors = [
                    'gp_bgcolor',
                    'gp_grapharea_f',
                    'gp_grapharea_b',
                    'gp_hbars',
                    'gp_total_drate1',
                    'gp_total_urate1',
                    'gp_sel_drate1',
                    'gp_sel_urate1',
                ]
        
        self.buttons = []
        for i in range(len(labels)):
            b_id = wx.NewId()
            butt = wx.Button(self, b_id, "")
            butt.SetBackgroundColour(self.btconfig.g_colors[ colors[i] ])
            b = [b_id, butt, colors[i]] 
            self.buttons.append(b)

            sizer.Add(labels[i], 1, wx.EXPAND | wx.ALIGN_LEFT)
            sizer.Add(b[1], 1, wx.ALIGN_RIGHT)

            wx.EVT_BUTTON(self, b[0], self.ChangeColor)
         
        resetButton = wx.Button(self, -1, "Reset to defaults")
        resetButton.Disable()
        sizer.Add(resetButton, 1)
        tall.AddGrowableCol(0)
        sizer.AddGrowableCol(0)
        sizer.AddGrowableCol(1)
               
        tall.Add(noteboxer, 1, wx.EXPAND)
        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()

    def GetColor(self, color = wx.Color(0,0,0)):
        data = None
        c_dlg = wx.ColourDialog(self)
        c_dlg.GetColourData().SetChooseFull(True)
        c_dlg.GetColourData().SetColour(color)
        if c_dlg.ShowModal() == wx.ID_OK:
            data = c_dlg.GetColourData()
        c_dlg.Destroy()
        if data != None:
            return data.GetColour()
        else:
            return None
    
    def ChangeColor(self, event):
        for b in self.buttons:
            if b[0] == event.GetId():
                current_color = b[1].GetBackgroundColour()
                color = self.GetColor(current_color)
                if color != None:
                    b[1].SetBackgroundColour(color)
                    self.btconfig.g_colors[ b[2] ] = color
                break
        
    def SaveSettings(self):
        self.btconfig.UpdateOptions()
        
#---------------------------------------------------------------------------
        
class Options_PG_Panel(wx.Panel):
    def __init__(self, parent, psize, btconfig):
        wx.Panel.__init__(self, parent, -1, size = psize)
        self.btconfig = btconfig        
        box = wx.StaticBox(self, -1, "Progress Gauge", size = psize)
        boxer = wx.StaticBoxSizer(box, wx.HORIZONTAL)
        tall = wx.FlexGridSizer(cols = 1, vgap = 2, hgap = 2)
        sizer = wx.FlexGridSizer(cols = 2, vgap = 2, hgap = 10)

        notebox = wx.StaticBox(self, -1, "Color Settings")
        noteboxer = wx.StaticBoxSizer(notebox, wx.VERTICAL)
        tall.Add((-1,10)) # spacer
        noteboxer.Add((-1,5))
        noteboxer.Add(sizer, 1, wx.EXPAND)
        
        labels = [0] * 5
        labels[0] = wx.StaticText(self, -1, "  Parts already downloaded:")
        labels[1] = wx.StaticText(self, -1, "  Parts requested:")
        labels[2] = wx.StaticText(self, -1, "  Parts not yet downloaded:")
        labels[3] = wx.StaticText(self, -1, "  Overall Progress:")
        labels[4] = wx.StaticText(self, -1, "  Text color:")
        
        colors = [
                    'g_have_color',
                    'g_requested_color',
                    'g_nothave_color',
                    'g_overall_color',
                    'g_text_color',
                ]
        
        self.buttons = []
        for i in range(len(labels)):
            b_id = wx.NewId()
            butt = wx.Button(self, b_id, "")
            butt.SetBackgroundColour(self.btconfig.g_colors[ colors[i] ])
            b = [b_id, butt, colors[i]] 
            self.buttons.append(b)

            sizer.Add(labels[i], 1, wx.EXPAND | wx.ALIGN_LEFT)
            sizer.Add(b[1], 1, wx.ALIGN_RIGHT)

            wx.EVT_BUTTON(self, b[0], self.ChangeColor)
         
        resetButton = wx.Button(self, -1, "Reset to defaults")
        resetButton.Disable()
        sizer.Add(resetButton, 1)
        tall.AddGrowableCol(0)
        sizer.AddGrowableCol(0)
        sizer.AddGrowableCol(1)
               
        tall.Add(noteboxer, 1, wx.EXPAND)
        boxer.Add(tall, 1, wx.EXPAND)
        self.SetSizer(boxer)
        self.Layout()

    def GetColor(self, color = wx.Color(0,0,0)):
        data = None
        c_dlg = wx.ColourDialog(self)
        c_dlg.GetColourData().SetChooseFull(True)
        c_dlg.GetColourData().SetColour(color)
        if c_dlg.ShowModal() == wx.ID_OK:
            data = c_dlg.GetColourData()
        c_dlg.Destroy()
        if data != None:
            return data.GetColour()
        else:
            return None
    
    def ChangeColor(self, event):
        for b in self.buttons:
            if b[0] == event.GetId():
                current_color = b[1].GetBackgroundColour()
                color = self.GetColor(current_color)
                if color != None:
                    b[1].SetBackgroundColour(color)
                    self.btconfig.g_colors[ b[2] ] = color
                break
        
    def SaveSettings(self):
        self.btconfig.UpdateOptions()

#---------------------------------------------------------------------------
        
class Options(wx.Frame):
    def __init__(self, parent = None, pos = wx.DefaultPosition, btconfig = None, bmps=None,
                    cfg_visflag = None, syncfunc = None):
        wx.Frame.__init__(self, None, -1, "Preferences", pos = pos, size = wx.Size(450, 380),
                          style = wx.DEFAULT_FRAME_STYLE | wx.STAY_ON_TOP | wx.FRAME_NO_TASKBAR)
        self.CentreOnScreen()
        self.btconfig = btconfig
        panel = wx.Panel(self, -1)
        panel.SetSize(self.GetClientSize())
        self.panel = panel
        self.rightpanel_size = (-1,-1)
        self.SyncFunc = syncfunc
        self.cfg_visflag = cfg_visflag
        
        if cfg_visflag != None:
            cfg_visflag.set()
        
        treeID = wx.NewId()
        self.tree = wx.TreeCtrl(panel, treeID, size = wx.Size(130,-1), style =  wx.TR_DEFAULT_STYLE | wx.TR_HIDE_ROOT | wx.TR_HAS_BUTTONS  | wx.TR_SINGLE )
        butID1 = wx.NewId()
        butID2 = wx.NewId()
        self.apply_but = wx.ToggleButton(panel, butID2, "Apply to existing torrents")
        self.close_but = wx.Button(panel, butID1, "Close")
        tt = wx.ToolTip("Click to apply options to all existing torrents")
        self.apply_but.SetToolTip(tt)
        tt = wx.ToolTip("Click to apply options to future torrents")
        self.close_but.SetToolTip(tt)

        
        border = wx.BoxSizer(wx.VERTICAL)
        splitter = wx.FlexGridSizer(cols = 2, hgap = 4)
        leftpane = wx.FlexGridSizer(cols = 1, vgap = 4)
        self.rightpane = wx.BoxSizer(wx.VERTICAL)

        border.Add(splitter, 1, wx.EXPAND | wx.ALL, 4)
        splitter.AddGrowableRow(0)
        splitter.AddGrowableCol(1)
        splitter.Add(leftpane, 1, wx.EXPAND)
        splitter.Add(self.rightpane, 1, wx.EXPAND)
                
        leftpane.AddGrowableRow(0)
        leftpane.Add(self.tree, 1, wx.EXPAND)
        leftpane.Add(self.apply_but, 1, wx.EXPAND)
        leftpane.Add(self.close_but, 1, wx.EXPAND)
        
        self.rightpane_panel = Options_Gen_Panel(panel, self.rightpanel_size, btconfig)
        self.rightpane.Add(self.rightpane_panel, 1, wx.EXPAND | wx.ALL)

        self.PopulateTree()       
        panel.SetSizer(border)
        panel.Layout()

        if bmps != None:
            self.SetIcon(bmps.GetImage('tbicon'))
        
        wx.EVT_TREE_SEL_CHANGED(panel, treeID, self.OnSelChanged)
        wx.EVT_BUTTON(self, butID1, self.Cleanup)
        wx.EVT_CLOSE(self, self.Cleanup)
        wx.EVT_ERASE_BACKGROUND(self, self.AntiFlicker)
        wx.EVT_SIZE(self, self.OnSize)
        wx.EVT_KEY_DOWN(self.tree, self.OnKeyDown)
        self.Show()
        
    def OnKeyDown(self, event):
        if event.GetKeyCode() == 27: #ESC key hit
            self.Cleanup()
        else:
            event.Skip()
        
    def OnSize(self, event=None):
        fsize = self.GetClientSize()
        self.panel.SetSize(fsize)
        psize = self.panel.GetClientSize()
        self.rightpanel_size = (psize[0] - (self.tree.GetSize()[0] + 10), psize[1]-9)
        self.rightpane_panel.SetSize(self.rightpanel_size)
        
    def AntiFlicker(self, event):
        pass
    
    def OnSelChanged(self, event):
        self.panel.Freeze()
        item = event.GetItem()
        self.rightpane_panel.SaveSettings()
        self.rightpane_panel.Destroy()

        if self.tree.GetItemText(item) == "General Options":
            self.rightpane_panel = Options_Gen_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) == "Peer List":
            self.rightpane_panel = Options_PL_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) == "Transfer Options":
            self.rightpane_panel = Options_Rate_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) == "Rate Options":
            self.rightpane_panel = Options_Rate_Panel(self.panel, self.rightpanel_size, self.btconfig)    
        elif self.tree.GetItemText(item) == "On Completion":
            self.rightpane_panel = Options_OnFin_Panel(self.panel, self.rightpanel_size, self.btconfig)    
        elif self.tree.GetItemText(item) == "Folder Options":
            self.rightpane_panel = Options_Fold_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) == "Network Options":
            self.rightpane_panel = Options_Net_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) == "Choker Options":
            self.rightpane_panel = Options_Choker_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) == "Connections":
            self.rightpane_panel = Options_Conn_Panel(self.panel, self.rightpanel_size, self.btconfig)            
        elif self.tree.GetItemText(item) == "Error Options":
            self.rightpane_panel = Options_Error_Panel(self.panel, self.rightpanel_size, self.btconfig)            
        elif self.tree.GetItemText(item) ==  "Color Options":
            self.rightpane_panel = Options_PG_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) ==  "Main View":
            self.rightpane_panel = Options_LVC_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) ==  "Progress Bar":
            self.rightpane_panel = Options_PG_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) ==  "Graph":
            self.rightpane_panel = Options_GRAPH_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) ==  "Web Interface":
            self.rightpane_panel = Options_WebI_Panel(self.panel, self.rightpanel_size, self.btconfig)
        elif self.tree.GetItemText(item) ==  "Client Spoofing":
            self.rightpane_panel = Options_Spoof_Panel(self.panel, self.rightpanel_size, self.btconfig)
        else:
            self.rightpane_panel = Options_Gen_Panel(self.panel, self.rightpanel_size, self.btconfig)

        self.rightpane.Add(self.rightpane_panel, 1, wx.EXPAND)
        self.panel.Layout()
        self.panel.Thaw()
        #self.rightpane_panel.SetSize(self.rightpanel_size)
        
        
    def Cleanup(self, *event):
        try:
            self.rightpane_panel.SaveSettings()
            self.btconfig.SaveOptions()
        except:
            print_exc()

        if self.SyncFunc != None:
            if self.apply_but.GetValue() and self.SyncFunc != None:
                self.SyncFunc(True)
            else:
                #Call with False to toggle some widgets in the main GUI
                self.SyncFunc(False)
        if self.cfg_visflag != None:
            self.cfg_visflag.clear()
        self.Destroy()
        
    def PopulateTree(self):
        root = self.tree.AddRoot("r3wt")

        c1 = self.tree.AppendItem(root, "General Options")
        c1a = self.tree.AppendItem(c1, "Peer List")
        c2 = self.tree.AppendItem(root, "Folder Options")
        c4 = self.tree.AppendItem(root, "Network Options")
        c9 = self.tree.AppendItem(root, "Error Options")
        c3 = self.tree.AppendItem(root, "Transfer Options")
        c3a = self.tree.AppendItem(c3, "Rate Options")
        c3b = self.tree.AppendItem(c3, "On Completion")
        c3c = self.tree.AppendItem(c3, "Choker Options")
        c3d = self.tree.AppendItem(c3, "Connections")
        c6 = self.tree.AppendItem(root, "Color Options")
        c6a = self.tree.AppendItem(c6, "Main View")
        c6b = self.tree.AppendItem(c6, "Progress Bar")
        c6c = self.tree.AppendItem(c6, "Graph")
        c7 = self.tree.AppendItem(root, "Web Interface")
        c8 = self.tree.AppendItem(root, "Client Spoofing")
    
        self.tree.Expand(c1)
        self.tree.Expand(c3)
        self.tree.Expand(c6)
        self.tree.SelectItem(c1)
        
        
        
#---------------------------------------------------------------------------
    
class OptionsPopup(wx.Frame):
    def __init__(self, parent, pos, btconfig):
        wx.Frame.__init__(self, parent, -1, "Options Popup", pos, (180,135), wx.SIMPLE_BORDER | wx.FRAME_NO_TASKBAR )
        panel = wx.Panel(self, -1)
        panel.SetSize( self.GetClientSize())
        self.SetSize(panel.GetSize())        
        panel.SetBackgroundColour(wx.SystemSettings_GetColour( wx.SYS_COLOUR_MENU  ))
        self.btconfig = btconfig

        colSizer = wx.FlexGridSizer(cols = 1, vgap = 5)
        gridSizer = wx.FlexGridSizer(cols = 2, vgap = 3, hgap = 2)

        label1 = wx.StaticText(panel, -1, "Upload Rate (KB/s):")
        label2 = wx.StaticText(panel, -1, "Max Uploads:")
        label3 = wx.StaticText(panel, -1, "Max Initiate:")
        label4 = wx.StaticText(panel, -1, "  Note: Upload Rate of 0 = unlimited\n"
                                        + "  Changes made here are specific to\n"
                                        + "  this DL only",
                                        size = wx.Size(140, 50))
        
        self.spin1 = wx.SpinCtrl(panel, -1, "", wx.Point(-1, -1), wx.Size(50, Widget_H))
        self.spin1.SetRange(0, 1000)
        self.spin1.SetValue(self.btconfig.Get('maxupspeed'))

        self.spin2 = wx.SpinCtrl(panel, -1, "", wx.Point(-1, -1), wx.Size(50, Widget_H))
        self.spin2.SetRange(0, 100)
        self.spin2.SetValue(self.btconfig.Get('maxuploads'))

        self.spin3 = wx.SpinCtrl(panel, -1, "", wx.Point(-1, -1), wx.Size(50, Widget_H))
        self.spin3.SetRange(0, 1000)
        self.spin3.SetValue(self.btconfig.Get('max_initiate'))
                
        gridSizer.Add(label1, 1, wx.EXPAND | wx.BOTTOM)
        gridSizer.Add(self.spin1, 1, wx.ALIGN_RIGHT)
        gridSizer.Add(label2, 1, wx.EXPAND | wx.BOTTOM)
        gridSizer.Add(self.spin2, 1, wx.ALIGN_RIGHT)
        gridSizer.Add(label3, 1, wx.EXPAND | wx.BOTTOM)
        gridSizer.Add(self.spin3, 1, wx.ALIGN_RIGHT)
        
        gridSizer.AddGrowableCol(0)

        colSizer.Add(gridSizer, 1, wx.EXPAND | wx.ALL, 6)
        colSizer.Add(wx.StaticLine(panel, -1, size = (self.GetClientSize()[0], 1),  style = wx.LI_HORIZONTAL), 1, wx.EXPAND)
        colSizer.Add(label4, 1, wx.EXPAND)
        
        self.SetSizer(colSizer)
        self.Layout()
        self.visible = True

        wx.EVT_ACTIVATE(self, self.OnLeaveWin)
        self.Show(True)
        
    def SaveSettings(self):
        self.btconfig.Set('maxupspeed', self.spin1.GetValue())
        self.btconfig.Set('maxuploads', self.spin2.GetValue())
        self.btconfig.Set('max_initiate', self.spin3.GetValue())
        
    def OnLeaveWin(self, evt):
        if evt.GetActive() == False and self.visible:
            self.Show(False)
            self.visible = False
            self.SaveSettings()
            self.btconfig.SyncOptions()
            self.optionsVisible = False
            self.Destroy()
        
    def EvtCheckBox(self, evt):
        if evt.IsChecked() == True:
            print 'checkbox checked'
        else:
            print 'checkbox unchecked'

    def ProcessLeftDown(self, evt):
        return False

#---------------------------------------------------------------------------


class RemoveTorrentDlg(wx.Dialog):
    def __init__(self, parent = None, pos = wx.DefaultPosition, btconfig = None, 
                    bmps = None, cfg_visflag = None):
        wx.Dialog.__init__(self, None, -1, "Remove Torrent", pos = pos, size = (190, 182),
                          style = wx.DEFAULT_DIALOG_STYLE | wx.STAY_ON_TOP )
        self.btconfig = btconfig
        panel = wx.Panel(self, -1)
        self.panel = panel
        self.cfg_visflag = cfg_visflag
        
        if cfg_visflag != None:
            cfg_visflag.set()

        choices = ["Don't delete anything",
                   "Delete .torrent file",
                   "Delete data file",
                   "Delete .torrent and data file",
                   ]
        
        RBOX1 = wx.NewId()
        self.radio1 = wx.RadioBox(panel, RBOX1, "Your move creep",
                        wx.DefaultPosition, wx.DefaultSize,
                        choices, 1, wx.RA_SPECIFY_COLS)
        #EVT_RADIOBOX(self, RBOX1, self.OnRadio) 
            
        self.apply2all = wx.CheckBox(panel, -1, "Apply to all selected")
        
        butID1 = wx.NewId()
        butID2 = wx.NewId()
        self.apply_but = wx.Button(panel, butID1, "Ok")
        self.cancel_but = wx.Button(panel, butID2, "Cancel")
        
        border = wx.BoxSizer(wx.VERTICAL)
        tall = wx.FlexGridSizer(cols = 1, hgap = 4)
        butgrid = wx.FlexGridSizer(cols = 2, hgap = 4)
        tall.AddGrowableCol(0)
        tall.AddGrowableRow(0)
        butgrid.AddGrowableCol(0)
        butgrid.AddGrowableCol(1)
        
        butgrid.Add(self.apply_but, 1, wx.EXPAND)
        butgrid.Add(self.cancel_but, 1, wx.EXPAND)
        
        tall.Add(self.radio1, 1, wx.EXPAND)
        tall.Add(butgrid, 1, wx.EXPAND)
        tall.Add((-1,5))
        tall.Add(self.apply2all, 1, wx.EXPAND)
        
        border.Add(tall, 1, wx.EXPAND | wx.ALL, 4)
        
        panel.SetSizer(border)
        panel.Layout()

        if bmps != None:
            self.SetIcon(bmps.GetImage('tbicon'))
        
        wx.EVT_BUTTON(self, butID1, self.Ok)
        wx.EVT_BUTTON(self, butID2, self.Cancel)
        wx.EVT_SIZE(self, self.OnSize)
        self.OnSize(0)


    def Apply2All(self):
        return self.apply2all.GetValue()

        
    def Ok(self, event):
        self.EndModal(self.radio1.GetSelection())

    
    def Cancel(self, event):
        self.EndModal(wx.ID_CANCEL) 
    
    
    def OnSize(self, event):
        fsize = self.GetClientSize()
        self.panel.SetSize(fsize)
        psize = self.panel.GetClientSize()


class SingleOption(wx.Frame):
    def __init__(self, parent = None, pos = wx.DefaultPosition, btconfig = None, 
                    panel_class = None, bmps = None, cfg_visflag = None):
        wx.Frame.__init__(self, None, -1, "Change Options", pos = pos, size = wx.DefaultSize,
                          style = wx.DEFAULT_FRAME_STYLE | wx.STAY_ON_TOP | wx.FRAME_NO_TASKBAR | wx.FRAME_TOOL_WINDOW )
        self.btconfig = btconfig
        panel = wx.Panel(self, -1)
        self.panel = panel
        self.cfg_visflag = cfg_visflag
        
        if cfg_visflag != None:
            cfg_visflag.set()
               
        butID1 = wx.NewId()
        butID2 = wx.NewId()
        self.apply_but = wx.Button(panel, butID1, "Apply")
        self.cancel_but = wx.Button(panel, butID2, "Cancel")
        
        if panel_class == "Choker":
            self.option_panel = Options_Choker_Panel(panel, (-1,-1), btconfig)
            self.SetSize((360, 360))
        elif panel_class == "OnFin":
            self.option_panel = Options_OnFin_Panel(panel, (-1,-1), btconfig)
            self.SetSize((350, 380))
        elif panel_class == "Rate":
            self.option_panel = Options_Rate_Panel(panel, (-1,-1), btconfig)
            self.SetSize((350, 350))
        elif panel_class == "Conn":
            self.option_panel = Options_Conn_Panel(panel, (-1,-1), btconfig)
            self.SetSize((350, 300))
        elif panel_class == "SchedCmd":
            self.option_panel = Options_SchedCmd_Panel(panel, (-1,-1), btconfig)
            self.SetSize((350, 280))
        else:
            self.option_panel = Options_Rate_Panel(panel, (-1,-1), btconfig)
            self.SetSize((350, 350))
            
        border = wx.BoxSizer(wx.VERTICAL)
        tall = wx.FlexGridSizer(cols = 1, hgap = 4)
        butgrid = wx.FlexGridSizer(cols = 2, hgap = 4)
        
        butgrid.Add(self.apply_but, 1, wx.EXPAND)
        butgrid.Add(self.cancel_but, 1, wx.EXPAND)
        tall.Add(self.option_panel, 1, wx.EXPAND)
        tall.Add(butgrid)
        tall.AddGrowableCol(0)
        tall.AddGrowableRow(0)
        border.Add(tall, 1, wx.EXPAND | wx.ALL, 4)
        
        panel.SetSizer(border)
        panel.Layout()

        if bmps != None:
            self.SetIcon(bmps.GetImage('tbicon'))
        
        wx.EVT_BUTTON(self, butID1, self.Apply)
        wx.EVT_BUTTON(self, butID2, self.Cleanup)
        wx.EVT_CLOSE(self, self.Cleanup)
        wx.EVT_SIZE(self, self.OnSize)
        self.Show()
        
    def OnSize(self, event):
        fsize = self.GetClientSize()
        self.panel.SetSize(fsize)
        psize = self.panel.GetClientSize()

    def Apply(self, event):
        self.option_panel.SaveSettings()
        self.btconfig.SyncOptions()
        self.Cleanup()
        
    def Cleanup(self, event=None):
        if self.cfg_visflag != None:
            self.cfg_visflag.clear()
        self.Destroy()
        
        
#---------------------------------------------------------------------------
        
if __name__ == "__main__":    
    app = wx.PySimpleApp()

#    ppp = About_Box(None, BTConfig(), Images())
#    ppp = OptionsPopup(None, (0,0), BTConfig())
    ppp = Options(None, btconfig = BTConfig())
#    ppp = SingleOption(None, btconfig = BTConfig(), panel_class = "Conn")
#    ppp = About_Box(None, BTConfig(), Images())
##    ppp = RemoveTorrentDlg(None, btconfig = BTConfig())
##    if ppp.ShowModal() != wx.ID_CANCEL:
##        print ppp.GetReturnCode()
##    ppp.Destroy()
    app.SetTopWindow(ppp)
    app.MainLoop()

