#-----------------------------------------------------------------------------
# Name:        urlfetch.py
# Purpose:     
#
# Author:      Jeremy Arendt
#
# Created:     2004/20/02
# RCS-ID:      $Id: urlfetch.py $
# Copyright:   (c) 2002
# Licence:     See G3.LICENCE
#-----------------------------------------------------------------------------
from threading import Thread
from urllib2 import URLError, urlopen 
from os.path import split, join
from urlparse import urlparse
from socket import gaierror
import sys

class T_FetchFile(Thread):

    def __init__(self, callback, callback_params, url, destpath):

        Thread.__init__(self)

        self.success = False

        self.callback = callback
        self.params = callback_params
        self.url = url
        self.path = destpath
        self.name = "Fetch"
        
    def run(self):
        try:
            filename = join(self.path, split(urlparse(self.url)[2])[1])
            h = urlopen(self.url)
        except (OSError, ValueError, URLError, gaierror), msg:
            print "Error fetching url", msg
            return False

        try:
            f = open(filename, 'wb')
            f.write(h.read())
            f.close()
            self.success = True
            self.callback( self.params, [filename] )
            return True
        except IOError, msg:
            self.success = False
            print msg
            return False


def dummy_callback(params1, params2):
    print params1, params2
    

if __name__ == "__main__":
    f = T_FetchFile(dummy_callback, "test", "http://localhost/test.torrent", "")
    f.start()
    